\section*{The \texttt{liblawless} Core}

Now,the original \gls{prelude} is a holdover from the early
1990s. Even in 1998, when it was estabilshed as a standard, much of it
was a throwback by several years in an effort to simplify the
language. However, in the process, they also reduced much of its
expressive power, and introduced a large number of functions that are
well-typed to the compiler, but at runtime can fail on common inputs.

To make things easier to learn, and easier for us to use for our daily
programming, we wrote our own core library, \gls{liblawless}. We’ve
eliminated functions that have obvious runtime errors
(\glspl{partialfunc}), so if a function compiles, it will either
return a value or an error type. We’ve included the \gls{lens} library
for simpler composition of the components of aggregate values, type
conversions, and different kinds of collections without pattern
matching.

Now, in the \mintinline{haskell}|BFWP.Greeting| module, after the \gls{explist},
there are five unqualified imports:

\begin{itemize}
\item \haskellinline|Lawless|
\item \haskellinline|IO|
\item \haskellinline|Text|
\item \haskellinline|Textual|
\item \haskellinline|Printer|
\end{itemize}

Each of these imports a different part of \gls{liblawless},
highlighting that where often there’s a single all-encompasing
\gls{prelude}, \gls{liblawless} takes a much more granular
approach. The only fairly large import is
\haskellinline|Lawless| itself, but unlike the \gls{prelude}, it
consists nearly entirely of safe functions with no effects. To get
code that affects the world outside the program, or even in the same
program but in separate threads, there are several other modules that
give you very specific control over the kind of effects you have
access to. \haskellinline|IO| is one such module, and in fact
builds on \haskellinline|Text|, \haskellinline|Textual|,
and \haskellinline|Printer| to provide \texttt{IO} effects that
operate in reversible parsing and printing. Ideally, if you write a
value, then read it, you’ll end up with the same value:

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../../FunctionalWeb"
%%% End:
